#include <QGraphicsObject>
#include <QImage>
#include <QPainter>
#include <QStyleOptionGraphicsItem>
#include <QDebug>
#include <QtCore>
#include <QDesktopServices>
#include "imagemasker.h"

ImageMasker::ImageMasker(QObject *parent) :
    QObject(parent)
{


}

void ImageMasker::modify(QObject *imageObj) {

    if (m_mask_image.isNull()) {
        qDebug() << "Mask Image is NULL " << m_mask_path;
    }

    QGraphicsObject *item = qobject_cast<QGraphicsObject*>(imageObj);
    if (!item) {
        qDebug() << "Item is NULL";
        return;
    }

/*
    for (int y = 0; y < sourceImage.height(); y++) {
        QRgb *target = (QRgb *)targetImage.scanLine(y);
        QRgb *source = (QRgb *)sourceImage.scanLine(y);
        QRgb *mask = (QRgb *)maskImage.scanLine(y);
        for (int x = 0; x < sourceImage.width(); x++) {
            *target = (*source & 0x00ffffff) | (((*mask & 0xff000000) >> 24) * ((*source & 0xff000000) >> 24) / 0xff) << 24;
            target++;
            source++;
            mask++;
        }
    }
*/
}

/*
void ImageMasker::save(QObject *imageObj, const QString &path)
{
    QGraphicsObject *item = qobject_cast<QGraphicsObject*>(imageObj);

    if (!item) {
        qDebug() << "Item is NULL";
        return;
    }

    QImage img(item->boundingRect().size().toSize(), QImage::Format_RGB32);
    img.fill(QColor(255, 255, 255).rgb());
    QPainter painter(&img);
    QStyleOptionGraphicsItem styleOption;
    item->paint(&painter, &styleOption);

    if (path != "") {
        qDebug() << "save " << path;
        img.save(path);
    } else {
        // DEFAULT PATH is JPEG according to timestamp
        QString mypath = QDesktopServices::storageLocation(QDesktopServices::PicturesLocation) + "/" + QDateTime::currentDateTime().toString("yyyyMMddhhmmss") + ".jpg";
        m_path = mypath;
        pathChanged();
        qDebug() << "save " << mypath;
        img.save(mypath);
    }

}
*/
