#ifndef IMAGEMASKER_H
#define IMAGEMASKER_H

#include <QObject>
#include <QImage>

class ImageMasker : public QObject
{
    Q_OBJECT

private:
    QString m_path;
    QString m_mask_path;
    QImage m_mask_image;

public:

//    Q_PROPERTY(QString path READ getPath WRITE setPath NOTIFY pathChanged)
    Q_PROPERTY(QString mask READ getMaskPath WRITE setMaskPath NOTIFY maskPathChanged)

    explicit ImageMasker(QObject *parent = 0);

    QString getMaskPath() { return m_mask_path; }
//    QString getPath() { return m_path; }
//    void setPath(QString _path) { m_path = _path; }
    void setMaskPath(QString _maks_path) { m_mask_path = _maks_path; m_mask_image.load(m_mask_path); }

public slots:
//    void save(QObject *item, const QString &path);
    void modify(QObject *item);

signals:
    void pathChanged();
    void maskPathChanged();

};


#endif // IMAGEMASKER_H
