import QtQuick 1.1
import com.nokia.meego 1.0

Page {
    tools: commonTools


    ListModel {
        id: model;
        ListElement {
            name: "Linuxepres"
            image: "./icons/linuxexpres.png"
            text: "Original file is a png"
        }
        ListElement {
            name: "Linuxepres"
            image: "image://mask/./qml/ImageMaskTester/icons/linuxexpres.png"
            text: "Modified file is a png"
        }

        ListElement {
            name: "Openmobility"
            image: "./icons/openmobility.png"
            text: "The png with transparent background"
        }
        ListElement {
            name: "Openmobility"
            image: "image://mask/./qml/ImageMaskTester/icons/openmobility.png"
            text: "The png with white background"
        }
        ListElement{
            name: "Myself"
            image: "./icons/me.jpg"
            text: "original jpeg"
        }
        ListElement{
            name: "Myself"
            image: "image://mask/./qml/ImageMaskTester/icons/me.jpg"
            text: "modified jpeg"
        }

    }

    ListView {
        anchors.fill: parent;
        model: model
        delegate: Rectangle {
            width: parent.width
            height: Math.max(icon.height, personMessage.height+personName.height) + 40
            color: mouseArea.pressed ?  Qt.darker("#e0e1e2") : "#e0e1e2"
            Image {
                id: icon
                source: model.image
                width: 80
                height: 80;
                anchors.left: parent.left
                anchors.verticalCenter: parent.verticalCenter
                anchors.margins: 10;
            }

            Text {
                id: personName;
                anchors.left: icon.right
                anchors.right: parent.right
                anchors.margins: 20;
                anchors.top: parent.top;
                height: paintedHeight
                text: model.name
                font.pixelSize: 26;
            }
            Text {
                id: personMessage
                anchors.top: personName.bottom
                anchors.left: icon.right
                anchors.right: parent.right
                anchors.margins: 20;
                text: model.text
                font.pixelSize: 20;
                wrapMode: Text.WordWrap
                height: paintedHeight
            }
            MouseArea {
                id: mouseArea
                anchors.fill: parent;
            }
        }
    }
}
